#include <includes.h>



float	cos_factor(float c,float MINVAL,float RMINVAL)
{
 	c=c*RMINVAL + MINVAL;

	if(c<0) c=0;

	return c;
}


void fish_update()
{
	fVector	*updateBuffer = (fVector *)(dSPAD+1);

	#if 0
	for(int n=0;n!=NUM_FISH;n++)
	{
	 	updateBuffer[n].x=0;
	 	updateBuffer[n].y=0;
	 	updateBuffer[n].z=0;
	 	updateBuffer[n].w=0;
	}
	#else
	vu1_invoke(&v_update0);
	#endif


	#if 0
	fishInfo	*fi_us=&dSPAD->fishArray[0];
	for(int n=0;n!=(NUM_FISH-1);n++)
	{
		fishInfo *fi_them=fi_us+1;

		// iterate over everyone else.. which means a temporary accumulate of updates
		for(int m=n;m!=NUM_FISH;m++)
		{
			// args are 

			
			// locals
			fVector	vThem;
			fVector	nThem;
			fVector	cos_vals;
			fVector	sca_vec;
			fVector	flk_vec;
			fVector	inc_vec;
			fVector	sep;



			vsub_xyz( &vThem, &fi_them->pos,&fi_us->pos);  // from us to them
			
			vnormlen(&nThem,&vThem);		// unit vector to them
			
			// dot from our direction towards them
			float adot = vdot_xyz( &fi_us->ahead, &nThem);

			vmuli_xyz( &cos_vals, &cSPAD->cosRcpVals, adot );
			vadd_xyz( & cos_vals, &cos_vals, & cSPAD->cosMinVals); 
			vclamp0_xyz( &cos_vals,&cos_vals);

			
			vsubi_xyz( &sca_vec,&cSPAD->distMinVals , nThem.w);
			vmul_z( &sca_vec,&sca_vec,&sca_vec);
			vmul_xyz(&sca_vec,&sca_vec,&cSPAD->distRcpVals);
			sca_vec.z+=1.0;
			vclamp0_xyz( &sca_vec,&sca_vec);


			vmul_xyz(&flk_vec,&sca_vec,&cos_vals);

			vstep1_xyz(&inc_vec,&flk_vec);
			
			// separation
			vmuli_xyz(&sep,&nThem,flk_vec.x);
			vsub_xyz(&updateBuffer[n],&updateBuffer[n],&sep);
			vadd_xyz(&updateBuffer[m],&updateBuffer[m],&sep);
			

			// aligment

				
		   	fVector	alg0;
		   	fVector	alg1;

			vmuli_xyz( &alg0,&fi_them->ahead,fi_them->ahead.w);
			vmuli_xyz( &alg1,&fi_us->ahead,fi_us->ahead.w);
		   	
			vmuli_xyz( &alg0,&alg0,flk_vec.y);
		   	vadd_xyz(&updateBuffer[n],&updateBuffer[n],&alg0);

			vmuli_xyz( &alg1,&alg1,flk_vec.y);
		   	vadd_xyz(&updateBuffer[m],&updateBuffer[m],&alg1);
				

			// coherence

			fVector	coh;
			vmuli_xyz(&coh,&nThem,flk_vec.z);
			vadd_xyz(&updateBuffer[n],&updateBuffer[n],&coh);
			vsub_xyz(&updateBuffer[m],&updateBuffer[m],&coh);
			
			
			
			float bAdd =  inc_vec.x+inc_vec.y+inc_vec.z;
			

			
			updateBuffer[n].w+=bAdd;		 
			updateBuffer[m].w+=bAdd;		 


			fi_them++;
		}

		// add force to origin

 		#if 1


		fVector org;
		vnormlen2(&org,&fi_us->pos);
		org.w=org.w*cSPAD->forceVals.w;

		org.w=org.w-0.5;
		if(org.w<0) org.w=0;
		
		
		// add force to keep in Y plane

		#if 1
		float f=fi_us->pos.y;
		f=fabsf(f);
		f=f-cSPAD->distMinVals.w;
		if(f<0) f=0;
		f=f*cSPAD->distRcpVals.w;
		updateBuffer[n].y*=(1-f);
		#endif

		fVector	sep;
		vmuli_xyz(&sep,&org,org.w);
		vsub_xyz(&updateBuffer[n],&updateBuffer[n],&sep);
		updateBuffer[n].w++;

		#endif


		fi_us++;
	}
	#else
	vu1_invoke(&v_update1);
	#endif



	#if 0

	// update

	fishInfo *fi=&dSPAD->fishArray[0];
	
	for(int n=0;n!=NUM_FISH;n++)
	{
		fVector	vel;

		float	r=1.0/updateBuffer[n].w;

		vmuli_xyz( &vel,&fi->ahead,fi->ahead.w);
		vel.x+=(updateBuffer[n].x)*r;
		vel.y+=(updateBuffer[n].y)*r;
		vel.z+=(updateBuffer[n].z)*r;
		vnormlen( & fi->ahead, &vel);


		if(fi->ahead.w > cSPAD->cosRcpVals.w)	fi->ahead.w=cSPAD->cosRcpVals.w;
		if(fi->ahead.w < cSPAD->cosMinVals.w)	fi->ahead.w=cSPAD->cosMinVals.w;
		
	    	float v=fi->ahead.w * T_FRAME;

	   	fi->pos.x = fi->pos.x + fi->ahead.x * v;
	    	fi->pos.y = fi->pos.y + fi->ahead.y * v;
	    	fi->pos.z = fi->pos.z + fi->ahead.z * v;
		
	
		fi++;
	}

  	#else

	vu1_invoke(&v_update2);

	#endif



}


// invoke function at  'label' in vu1:
//	1. copy all of SPR into vu1 ram
//	2. call function at label
//	3. copy vu1 ram back to spr

void	vu1_invoke( void *label )
{
 	asm __volatile__ ("sync.l");
 	asm __volatile__ ("sync.p");
	vu1_sync();

	u_long *r_p = (u_long128 *)SPAD;
	u_long *w_p = (u_long128 *)VU1_MEM;

	//dump_spad();

	for(int n=0;n!=2048;n++)
	{
	 	*w_p++=*r_p++;
	}

	u_int offset=(u_int)label - (u_int)&VuFish_CodeStart;
	offset=offset>>3;

	//printf("offset=%x for call\n",offset);

 	asm __volatile__ (" ctc2	%0,$31 " :: "r" (offset) ); 
	asm __volatile__ ("sync.p");	
	asm __volatile__ ("sync.l");	


 	vu1_sync();	

	// copy back from vu1

	vu1_sync();
 	asm __volatile__ ("sync.l");
 	asm __volatile__ ("sync.p");

	r_p = (u_long *)VU1_MEM;
	w_p = (u_long *)SPAD;

	for(int n=0;n!=2048;n++)
	{
	 	*w_p++=*r_p++;
	}

	//dump_spad();

 	asm __volatile__ ("sync.l");


}

