; 150 quads per buffer allows 11 triangles to fit ok..
; after the kick use location 0 as a place to store buffer offset etc

	
	.include	"basic_vu.i"
	.include	"spad.i"
	.include	"demu.i"
	.include	"vumacros.m"
	.include	"gs.i"



BUFFER_SIZE	.equ	150

	.macro	get_world_vert	v,i
	iand	\i,\i,imask	       		; mask off non-triangle bits
	iadd	\i,\i,\i			; double it to get offset into verices
	lq	\v, sp_theFishModel+1(\i)	; and read the value
	lq	abc, sp_theFishModel+2(\i)	; and read the value
	
	mul.w	acc,sin,abc[w]
	madd.w	abc,cos,abc[z]
	mul.w	abc,abc,wibble
	add.x	\v,\v,abc[w]
	.endm


	.macro	rtp_vert_q	f,v
	mul	acc,o2t[0],\v[x]
	madd	acc,o2t[1],\v[y]
	madd	acc,o2t[2],\v[z]
	madd	ab,o2t[3],vf00[w]
	div	q,vf00[w],ab[w]
	mul.xyz	ab,ab,q
 	ftoi4.xyz \f,ab

	mr32.z		ab,ab
	add.xyz		ab,ab,clipAdd
	mul.xyz		ab,ab,clipMul
	clipw.xyz	ab,vf00
	.endm




	.macro	rtp_vert_p	f,v
	mul	acc,o2t[0],\v[x]
	madd	acc,o2t[1],\v[y]
	madd	acc,o2t[2],\v[z]
	madd	ab,o2t[3],vf00[w]
	ercpr	P,ab[w]
	mfp.w	tmp\@,P
	mul.xyz	ab,ab,tmp\@[w]

	
	ftoi4.xyz \f,ab

	mr32.z		ab,ab
	add.xyz		ab,ab,clipAdd
	mul.xyz		ab,ab,clipMul
	clipw.xyz	ab,vf00
	.endm




	
 	--enter
	--endenter


	gs_sendreg_init	
	
	gs_send_sync
	gs_sendreg_long	GS_TEST_1, dml_test_vanilla
	gs_send_sync


	iaddiu	bufferOffset,vi00,0
	iaddiu	fi_p,vi00,sp_fishTable

draw_fish_loop:
	
;	read in fish info

	lq   		pos,fi_pos(fi_p)
	lq    		fmat[2],fi_ahead(fi_p)

	loi		1.0e-1
	add.w		pos,pos,i
	sq.w		pos,fi_pos(fi_p)

; sin/cosine.. 

	maxw		ONE,vf00,vf00	
	lq		a_const,sp_angConsts(vi00)
	lq		s_taylor,sp_sinTaylor(vi00)
	lq		c_taylor,sp_cosTaylor(vi00)

	mfir.w	      	sin,vi00			; basically, w has to be zero!
	mfir.w	      	cos,vi00			; for the mr32 at end to work..

	mulx.w      	ssign,pos,a_const		; max value
	minix.w		ssign,ssign,vf00       		; clamp above 0.0
	loi	      	-2.0
	maxi.w      	ssign,ssign,i	 		; clamp to -2 below
	addw.w      	ssign,ssign,vf00		; now.. -1 or 1	 !

	abs.w		angles,pos			; abs value
	ftoi0.w		iang,angles			; integer parts
	
	iaddiu 		three,vi00,3
	
	mtir	      	w_int,iang[w]
	iand   		w_int,w_int,three
	lq.w   		flip,sp_FBT(w_int)
	lq.w   		sin_sign,sp_SST(w_int)
	lq.w  		cos_sign,sp_CST(w_int)
	
	
	mul.w		sin_sign,ssign,sin_sign
	
	itof0.w		ifang,iang
	sub.w		angles,angles,ifang	   		; angle 0-1
	
	mul.w		ang2,angles,angles
	mul.w		ang3,ang2,angles
	mul.w		ang4,ang2,ang2
	mul.w		ang5,ang3,ang2
	mul.w		ang6,ang3,ang3
	mul.w		ang7,ang3,ang4
	mul.w		ang8,ang4,ang4
	mul.w		ang9,ang5,ang4
	mul.w		ang10,ang5,ang5
	
	mulaz.w	acc,angles,a_const
     	maddax.w	acc,ang3,s_taylor
     	madday.w	acc,ang5,s_taylor
      	maddaz.w	acc,ang7,s_taylor
       	maddw.w	tsin,ang9,s_taylor
	
	mula.w   	acc,ONE,ONE
	maddaw.w	acc,ang2,a_const
	maddax.w	acc,ang4,c_taylor
	madday.w	acc,ang6,c_taylor
	maddaz.w	acc,ang8,c_taylor
	maddw.w	tcos,ang10,c_taylor
	
	sub.w		mflip,ONE,flip
	mula.w   	acc,tcos,flip  		; flip=1.0 if flip, else 0.0
	madd.w   	sin,tsin,mflip
	
	mula.w   	acc,tsin,flip  		; flip=1.0 if flip, else 0.0
	madd.w   	cos,tcos,mflip 		
	
	mul.w		sin,sin,sin_sign	; set correct signs
	mul.w		cos,cos,cos_sign

	loi	2.0e-1
	mul.w	wibble,vf00,i
	




	iaddiu		fi_p,fi_p,fi_sizeof

;	build fish orientation matrix

	move.xyz	fmat[3],pos

	mr32  		yUp,vf00
	mr32   		yUp,yUp

	opmula.xyz	acc,yUp,fmat[2]
	opmsub.xyz	tmpa,fmat[2],yUp

	max		ONE,vf00,vf00[w]
	normalise_q_x	fmat[0],tmpa

	opmula.xyz	acc,fmat[2],fmat[0]
	opmsub.xyz	fmat[1],fmat[0],fmat[2]

	sub.w		fmat[0],vf00,vf00
	sub.w		fmat[1],vf00,vf00
	sub.w		fmat[2],vf00,vf00
	move.w		fmat[3],vf00

;	multiply with world-2-telly

	loadMat		w2t,sp_w2telly,vi00
	mulMat		o2t,fmat,w2t

;	well - that's built the object 2 telly matrix..


;	TODO
;	compute angles here!
;	TODO
;	compute angles here!
;	TODO


;	now render the triangles in the fish- do it in 4 blocks of 22

	

	iaddiu	in_p,vi00,sp_theFishModel+1	; read pointer for triangles
	isw.x	in_p,0(vi00)			; store to 0

;	set the giftag in the buffer

	loi	2.0e-1
	add.x	col_val,vf00,i
	loi	180
	add.y	col_val,vf00,i



outer_tri_loop:
	ilw	in_p,0(vi00)x
	iaddiu	end_in_p,in_p,11		; end marker for triangles
	
	iaddiu	out_p,bufferOffset,1024-(BUFFER_SIZE*2)	; output buffer here


	lq.yzw	giftag,sp_lineStripTag(vi00)  	; read giftag
	
	iaddiu	tmp,vi0,0x7fff
	iaddiu	tmp,tmp,1+11			; eop+count
	isw.x	tmp,(out_p)

	sqi.yzw	giftag,(out_p++)		; store giftag

	

		

	move	rgba,vf00
	iaddiu	icol,vi00,0xf0
	mfir	rgba,icol

	lq	clipAdd,sp_clipAdd(vi00)
	lq	clipMul,sp_clipMul(vi00)

	loi	255
	iaddiu	imask,vi00,((1<<6)-1)
inner_tri_loop:
      	--LoopCS	11,4
	--LoopExtra	2
	fcset		0

	lqi		tri,(in_p++)			; read triangle


	mtir		i0,tri[x]
	get_world_vert	v0,i0
	rtp_vert_q	f0,v0

	mtir		i1,tri[y]
	get_world_vert	v1,i1
	rtp_vert_q	f1,v1

	mtir		i2,tri[z]
	get_world_vert	v2,i2
	rtp_vert_q	f2,v2

	sub.xyz		a,v1,v0
	sub.xyz		b,v2,v0
	opmula.xyz	acc,a,b
	opmsub.xyz	c,b,a

	erleng		P,c
	mfp.w		tmp,P

      ;	normalise_q_x	nrm,c


	mul.xyz		acc,fmat[0],c[x]
	madd.xyz 	acc,fmat[1],c[y]
	madd.xyz 	c,fmat[2],c[z]
	mul.xyz		nrm,c,tmp[w]

	add.x	lt,nrm,nrm[y]
	
	add.xyz	lt,vf00,lt[x]
	move.w	lt,vf00
	mul.xyz	lt,lt,lt
	mul.xyz	lt,lt,lt
	
	add.xyz	lt,lt,col_val[x]
	mul	lt,lt,col_val[y]
	
	minii	lt,lt,i
	ftoi0	rgba,lt
	
	sq	rgba,ft_rgba(out_p)		; save colour	
	sq.xyz	f0,ft_xyz0(out_p)
	sq.xyz	f1,ft_xyz1(out_p)
	sq.xyz	f2,ft_xyz2(out_p)

	fcand	vi01,0x3ffff
	iaddiu	adc,vi01,0x7fff
	isw.w	adc,ft_xyz2(out_p)

	
	iaddiu	out_p,out_p,ft_sizeof
	
;	check to see if we reached the end of the input triangles
	
	ibne	in_p,end_in_p,inner_tri_loop



;	kick buffer..

	iaddiu	out_p,bufferOffset,1024-(BUFFER_SIZE*2)
	xgkick	out_p
	gs_send_sync
	
;	flip buffer

	iaddiu	buffer_size,vi00,BUFFER_SIZE
	isub	bufferOffset,buffer_size,bufferOffset

	ilw	in_p,0(vi00)x
	iaddiu	in_p,in_p,11
	isw.x	in_p,0(vi00)
	iaddiu	end_in_p,vi00,sp_theFishModel+1+88
	
	ibne	end_in_p,in_p,outer_tri_loop		; back for more triangles if not done all

;	rendered that fish, so have we done all the fish?

	iaddiu	fi_end_p,vi00,sp_fishTable+(NUM_FISH*2)
	ibne	fi_end_p,fi_p,draw_fish_loop



	--exitm
	--endexit


